#include "array.h"
#include <stdio.h> // for printf

/**
 * Create a new Array1d, allocate memory and retrun pointer to it.
 */
Array1d * Array1d_new(int n) {

  /* memory allocation for Array1d structure */
  Array1d* result = malloc( sizeof(Array1d) );

  /* initialize Array1d members */
  result->n = n;
  result->data = (real_t *) malloc (n * sizeof(real_t) );

  // here we should check that memory allocation was OK. TODO.

  /* return structure pointer */
  return result;

} // Array1d_new

/**
 *
 */
void Array1d_free(Array1d *array) {

  /* free memory of array members */
  free(array->data);

  /* free memory of array itself */
  free(array);

} // Array1d_free

/**
 *
 */
void Array1d_print(const Array1d* array) {
  
  // print some header ?
  printf("-----------------------------------\n");
  printf("dump data for Array1d at address %p\n",array);

  // print data
  for (int i=0; i<array->n; i++)
    printf("%f ",array->data[i]);
  printf("\n");

  // print footer
  printf("-----------------------------------\n");

} // Array1d_print

/**
 * return value at index (we do not check that index is in valid range,
 * be careful).
 */
real_t Array1d_get(const Array1d* array, int i) {
  
  return array->data[i];

} // Array1d_get

/**
 * return value at index (we do not check that index is in valid range,
 * be careful).
 */
void Array1d_set(Array1d* array, int i, real_t value) {
  
  array->data[i] = value;

} // Array1d_set


/*********************************************************/

/**
 * Create a new Array2d, allocate memory and retrun pointer to it.
 */
Array2d * Array2d_new(int nx, int ny) {

  /* memory allocation for Array2d structure */
  Array2d* result = malloc( sizeof(Array2d) );

  /* initialize Array1d members */
  result->nx = nx;
  result->ny = ny;
  result->data = (real_t *) malloc (nx * ny * sizeof(real_t) );

  // here we should check that memory allocation was OK. TODO.

  /* return structure pointer */
  return result;

} // Array2d_new

/**
 *
 */
void Array2d_free(Array2d *array) {

  /* free memory of array members */
  free(array->data);

  /* free memory of array itself */
  free(array);

} // Array2d_free

/**
 *
 */
void Array2d_print(const Array2d* array) {
  
  // print some header ?
  printf("-----------------------------------\n");
  printf("dump data for Array2d at address %p\n",array);

  // print data
  for (int j=0; j<array->ny; j++) {
    for (int i=0; i<array->nx; i++)
      printf("%f ",array->data[i+array->nx*j]);
    printf("\n");
  }

  // print footer
  printf("-----------------------------------\n");

} // Array2d_print
