/**
 *
 *
 */

#ifndef ARRAY_H_
#define ARRAY_H_

#include <stdlib.h> // for malloc

#include "real_type.h"

/**************************************************/
/**************************************************/
/**************************************************/

/**
 * 1d array.
 */
struct Array1d {
  int n;         /*!< size in element */
  real_t *data;  /*!< pointer to data array */
};
typedef struct Array1d Array1d;

/* Array1d routines. */
Array1d * Array1d_new  (int n);
void      Array1d_free (Array1d *array);
void      Array1d_print(const Array1d* array);
real_t    Array1d_get  (const Array1d* array, int i);
void      Array1d_set  (Array1d* array, int i, real_t value);

/**
 * 2d array. Storage is column major order.
 */
struct Array2d {
  int nx, ny;    /*!< sizes in element in each direction */
  real_t *data;  /*!< pointer to data array */
};
typedef struct Array2d Array2d;

/* Array2d routines. */
Array2d * Array2d_new  (int nx, int ny);
void      Array2d_free (Array2d *array);
void      Array2d_print(const Array2d* array);


#endif // ARRAY_H_
