#ifndef MONITORING_H_
#define MONITORING_H_

#include <time.h>     // for struct timeval
#include <sys/time.h> // for gettimeofday and struct timeval

typedef struct timeval timeval_t;

/**
 * structure used to measure exec time with gettimeofday.
 */
struct Timer {
  timeval_t start_time;

  /** store total accumulated timings */
  double    total_time;
};
typedef struct Timer Timer;


void   timerReset  (Timer* timerPtr);
void   timerStart  (Timer* timerPtr);
void   timerStop   (Timer* timerPtr);
double timerElapsed(Timer* timerPtr);

/*
 * some global timers for our need.
 */
extern Timer total_timer, godunov_timer, dt_timer, boundaries_timer, io_timer;

#endif // MONITORING_H_
